//########## Mech

//### Sound

datablock AudioProfile(gc_MechStep1Sound)
{
  filename = "./step1.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_MechStep2Sound)
{
  filename = "./step2.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_MechImpactSound)
{
  filename = "./mechimpact.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_MechJetSound)
{
  filename = "./jet.wav";
  description = AudioCloseLooping3d;
  preload = true;
};

datablock AudioProfile(gc_MechJetOffSound)
{
  filename = "./jetoff.wav";
  description = AudioClose3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_MechJetParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 250;
  lifetimeVarianceMS = 50;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 1 0.5 1";
  colors[1] = "1 0.6 0.2 0.5";
  colors[2] = "1 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 1;
  sizes[2] = 1;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_MechJetEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 25;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechJetParticle";
};

datablock ParticleData(gc_MechJetGroundParticle)
{
  dragCoefficient = 1;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 1 1 0";
  colors[1] = "0.5 0.5 0.5 0.25";
  colors[2] = "0.5 0.5 0.5 0";
  sizes[0] = 1;
  sizes[1] = 2;
  sizes[2] = 3;
  times[0] = 0;
  times[1] = 0.3;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_MechJetGroundEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 5;
  ejectionOffset = 0;
  thetaMin = 80;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechJetGroundParticle";
};

datablock ParticleData(gc_MechImpactParticle)
{
  dragCoefficient = 1;
  gravityCoefficient = 2;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/chunk";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 1";
  sizes[0] = 0.3;
  sizes[1] = 0;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_MechImpactEmitter)
{
  uiName = "";
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 15;
  velocityVariance = 10;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 45;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechImpactParticle";
};

datablock ParticleData(gc_MechImpactSmokeParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0.5 0.5 0.5 1";
  colors[1] = "0.5 0.5 0.5 0";
  sizes[0] = 3;
  sizes[1] = 6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_MechImpactSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 25;
  velocityVariance = 20;
  ejectionOffset = 0;
  thetaMin = 45;
  thetaMax = 80;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechImpactSmokeParticle";
};

datablock ExplosionData(gc_MechImpactExplosion)
{
  lifeTimeMS = 250;
  emitter[0] = gc_MechImpactEmitter;
  emitter[1] = gc_MechImpactSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  soundProfile = gc_MechImpactSound;
  shakeCamera = true;
  camShakeFreq = "0.5 0.5 0.5";
  camShakeAmp = "10 10 10";
  camShakeDuration = 2;
  camShakeRadius = 10;
};

datablock ProjectileData(gc_MechImpact)
{
  uiName = "";
  explosion = gc_MechImpactExplosion;
  lifetime = 1;
  fadeDelay = 1;
  explodeOnDeath = true;
};

//### Player

datablock TSShapeConstructor(mechDts)
{
  baseShape = "./mech.dts";
  sequence0 = "./root.dsq root";

  sequence1 = "./walk.dsq walk";
  sequence2 = "./walk.dsq run";
  sequence3 = "./back.dsq back";
  sequence4 = "./side.dsq side";

  sequence5 = "./root.dsq crouch";
  sequence6 = "./walk.dsq crouchRun";
  sequence7 = "./back.dsq crouchBack";
  sequence8 = "./side.dsq crouchSide";

  sequence9 = "./look.dsq look";
  sequence10 = "./lookLeftRight.dsq headSide";

  sequence11 = "./jump.dsq jump";
  sequence12 = "./jump.dsq standjump";
  sequence13 = "./fall.dsq fall";
  sequence14 = "./root.dsq land";

  sequence15 = "./armattack.dsq armAttack";
  sequence16 = "./armreadyleft.dsq armReadyLeft";
  sequence17 = "./armreadyright.dsq armReadyRight";
  sequence18 = "./armreadyboth.dsq armReadyBoth";

  sequence19 = "./sit.dsq sit";
  sequence20 = "./wrench.dsq wrench";

  sequence21 = "./activate.dsq activate";
  sequence22 = "./armattack.dsq activate2";

  sequence23 = "./punch1.dsq punch1";
  sequence24 = "./punch2.dsq punch2";

  sequence25 = "./death1.dsq death1";

  sequence26 = "./plant.dsq plant";
  sequence27 = "./shiftleft.dsq shiftLeft";
  sequence28 = "./shiftright.dsq shiftRight";
  sequence29 = "./shiftup.dsq shiftUp";
  sequence30 = "./shiftdown.dsq shiftDown";
  sequence31 = "./shiftaway.dsq shiftAway";
  sequence32 = "./shiftto.dsq shiftTo";
  sequence33 = "./rotcw.dsq rotCW";
  sequence34 = "./rotccw.dsq rotCCW";
};

datablock PlayerData(gc_MechPlayer : PlayerStandardArmor)
{
  renderFirstPerson = true;
  uiName = "Mech";
  shapeFile = "./mech.dts";
  FootHardSound = gc_MechStepSound;
  FootSoftSound = gc_MechStepSound;
  maxForwardSpeed = 9;
  jetEmitter = gc_MechJetEmitter;
  jetGroundDistance = 10;
  jetGroundEmitter = gc_MechJetGroundEmitter;
  stepHeight = 2;
  maxDamage = 200;
  boundingBox = "11 11 19";
  crouchBoundingBox = "11 11 19";
  mass = 110;
  minJetEnergy = 10;
  jetEnergyDrain = 2;
  showEnergyBar = 1;
  pickupRadius = 2;
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
  useCustomPainEffects = true;
  PainHighImage = "";
  PainMidImage = "";
  PainLowImage = "";
  painSound = "";
  deathSound = "";
  minImpactSpeed = 20;
  canride = 0;
  footstepdelay = 290;
  gc_shield = 200;
  gc_isMech = 1;
};

function gc_MechPlayer::onAdd(%this,%obj)
{
  parent::onAdd(%this,%obj);
  %obj.shield = %obj.dataBlock.gc_shield;
  %obj.shielddelay = 0;
  gc_MechStatus(%obj);
}

function gc_MechStatus(%obj)
{
  if(!isObject(%obj)) return;
  if(%obj.dataBlock.getName() !$= "gc_MechPlayer") return;
  if(%obj.shielddelay > 0) %obj.shielddelay -= 1;
  else if(%obj.shield < %obj.dataBlock.gc_shield) %obj.shield = mClampF(%obj.shield+20,0,%obj.dataBlock.gc_shield);
  schedule(500,0,"gc_MechStatus",%obj);
  %client = %obj.client;
  if(!isObject(%client)) return;

  %shield = mFloor((%obj.shield / %obj.dataBlock.gc_shield)*20);
  %health = mFloor((1 - %obj.getDamagePercent())*20);
  %jet = mFloor(%obj.getEnergyPercent()*20);

  if(%shield < 5) %a = "\c0";
  else if(%shield < 10) %a = "\c3";
  else
    %a = "\c4";
  if(%health < 5) %b = "\c0";
  else if(%health < 10) %b = "\c3";
  else
    %b = "\c4";
  if(%jet < 5) %c = "\c0";
  else if(%jet < 10) %c = "\c3";
  else
    %c = "\c4";

  for(%i=0;%i<%shield;%i++) %a = %a @ "=";
  %a = %a @ "\c7";
  for(%i=0;%i<20-%shield;%i++) %a = %a @ "=";
  for(%i=0;%i<%health;%i++) %b = %b @ "=";
  %b = %b @ "\c7";
  for(%i=0;%i<20-%health;%i++) %b = %b @ "=";
  for(%i=0;%i<%jet;%i++) %c = %c @ "=";
  %c = %c @ "\c7";
  for(%i=0;%i<20-%jet;%i++) %c = %c @ "=";

  %systemstatus = "\c2Not a scratch!";
  if(%health < 5 && %shield == 0) %systemstatus = "\c0System Failure Imminent!";
  if(%health < 5 && %shield < 5) %systemstatus = "\c0Critical!";
  else if(%health < 10) %systemstatus = "\c0Damaged!";
  else if(%shield == 0) %systemstatus = "\c3Shields down!";
  bottomprint(%client,"<just:center>\c4System Status: " @ %systemstatus @ "<br>\c4Shields: " @ %a @ "<br>\c4Health: " @ %b @ "<br>\c4Jetpack: " @ %c,1);
}
