//########## Mech Autocannon

//### Sounds

datablock AudioProfile(gc_magInSound)
{
  filename = "./magin.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(gc_magOutSound)
{
  filename = "./magout.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(gc_MechcannonFireSound)
{
  filename = "./mechcannon.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_MechcannonHitSound)
{
  filename = "./mechcannonhit.wav";
  description = AudioClose3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_MechcannonFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 60;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/star1";
  spinSpeed = 0;
  spinRandomMin = -5000;
  spinRandomMax = 5000;
  colors[0] = "1 1 0 1";
  colors[1] = "1 0.8 0.2 1";
  colors[2] = "1 0 0 0";
  sizes[0] = 0.3;
  sizes[1] = 3;
  sizes[2] = 1;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_MechcannonFlashEmitter)
{
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 30;
  velocityVariance = 5;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechcannonFlashParticle";
  uiName = "";
};

datablock ParticleData(gc_MechcannonTrailParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 200;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/dot";
  spinSpeed = 0;
  spinRandomMin = -5000;
  spinRandomMax = 5000;
  colors[0] = "1 1 0 1";
  colors[1] = "1 0.8 0.2 1";
  colors[2] = "1 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 0.2;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_MechcannonTrailEmitter)
{
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0.1;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechcannonTrailParticle";
  uiName = "";
};

datablock ParticleData(gc_MechcannonExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 100;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/star1";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 4;
  sizes[1] = 2;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_MechcannonExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 1;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechcannonExplosionParticle";
};

datablock ParticleData(gc_MechcannonSmokeParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 2;
  sizes[1] = 4;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_MechcannonSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 10;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 5;
  ejectionOffset = 1;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechcannonSmokeParticle";
};

datablock ExplosionData(gc_MechcannonExplosion)
{
  lifeTimeMS = 100;
  soundProfile = gc_MechcannonHitSound;
  emitter[0] = gc_MechcannonExplosionEmitter;
  emitter[1] = gc_MechcannonSmokeEmitter;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "5 5 5";
  camShakeDuration = 1;
  camShakeRadius = 6;
  radiusDamage = 25;
  damageRadius = 3;
  impulseForce = 500;
  impulseRadius = 6;
};

datablock DebrisData(gc_MechcannonShellDebris)
{
  shapeFile = "./mechcannonshell.dts";
  lifetime = 2;
  minSpinSpeed = -400;
  maxSpinSpeed = 200;
  elasticity = 0.5;
  friction = 0.2;
  numBounces = 3;
  staticOnMaxBounce = true;
  snapOnMaxBounce = false;
  fade = true;
  gravModifier = 2;
};

//### Projectile

AddDamageType("gc_Mechcannon",'<bitmap:Add-ons/Vehicle_Mechh/CI_mechcannon> %1','%2 <bitmap:Add-ons/Vehicle_Mechh/CI_mechcannon> %1',0.2,1);

datablock ProjectileData(gc_MechcannonProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 50;
  directDamageType = $DamageType::gc_Mechcannon;
  radiusDamageType = $DamageType::gc_Mechcannon;
  brickExplosionRadius = 2;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 24;
  brickExplosionMaxVolumeFloating = 24;
  impactImpulse = 1000;
  verticalImpulse = 300;
  explosion = gc_MechcannonExplosion;
  particleEmitter = gc_MechcannonTrailEmitter;
  muzzleVelocity = 200;
  verInheritFactor = 0;
  lifetime = 5000;
  fadeDelay = 5000;
  armingDelay = 0;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 1;
};

//### Item

datablock ItemData(gc_MechcannonItem)
{
  uiName = "Mech Autocannon";
  iconName = "./icon_mechcannon";
  image = gc_MechcannonImage;
  category = Weapon;
  className = Weapon;
  shapeFile = "./mechcannon.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock shapeBaseImageData(gc_MechcannonImage)
{
  shapeFile = "./mechcannon.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = gc_MechcannonItem;
  ammo = "";
  projectile = gc_MechcannonProjectile;
  projectileType = Projectile;
  projectilemagcount = 40;
  casing = gc_MechcannonShellDebris;
  shellExitDir = "1 0.5 0.2";
  shellExitVariance = 10;
  shellVelocity = 6;
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "AmmoCheck";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;
  stateTransitionOnNoAmmo[1] = "Reload";

  stateName[2] = "Fire";
  stateTransitionOnTimeout[2] = "AmmoCheck";
  stateTimeoutValue[2] = "0.15";
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateWaitForTimeout[2] = true;
  stateEmitter[2] = gc_MechcannonFlashEmitter;
  stateEmitterTime[2] = 0.05;
  stateEmitterNode[2] = "muzzlePoint";
  stateSound[2] = gc_MechcannonFireSound;
  stateScript[2] = "onFire";
  stateSequence[2] = "Fire";
  stateEjectShell[2] = true;

  stateName[3] = "AmmoCheck";
  stateTransitionOnTimeout[3] = "Ready";
  stateAllowImageChange[3] = true;
  stateScript[3] = "onAmmoCheck";

  stateName[4] = "Reload";
  stateTimeoutValue[4] = 4;
  stateTransitionOnTimeout[4] = "Done";
  stateWaitForTimeout[4] = true;
  stateAllowImageChange[4] = true;
  stateScript[4] = "onReloadStart";
  stateSequence[4] = "Empty";
  stateSound[4] = gc_MagOutSound;

  stateName[5] = "Done";
  stateTransitionOnTimeout[5] = "Ready";
  stateTimeoutValue[5] = 0.1;
  stateAllowImageChange[5] = true;
  stateScript[5] = "onReload";
  stateSound[5] = gc_MagInSound;
  stateSequence[5] = "Ready";
};

function gc_MechcannonImage::onMount(%this,%obj,%slot) { parent::onMount(%this,%obj,%slot); if(!%obj.dataBlock.gc_isMech) { centerPrint(%obj.client,"Only a Mech can use this!",3); %obj.unmountImage(%slot); return; } }
function gc_MechcannonImage::onAmmoCheck(%this,%obj,%slot) { if(%obj.toolMag[%obj.currTool] > %this.projectilemagcount) { %obj.toolMag[%obj.currTool] = %this.projectilemagcount; } if(%obj.toolMag[%obj.currTool] < 1) { %obj.toolMag[%obj.currTool] = 0; %obj.setImageAmmo(0,0); } }
function gc_MechcannonImage::onReloadStart(%this,%obj,%slot) { %obj.playThread(2,shiftRight); serverPlay3D(gc_FLReloadStartSound,%obj.getPosition()); }
function gc_MechcannonImage::onReload(%this,%obj,%slot) { %obj.playThread(2,plant); serverPlay3D(gc_FLReloadEndSound,%obj.getPosition()); %obj.toolMag[%obj.currTool] = %this.projectilemagcount; %obj.setImageAmmo(0,1); }

function gc_MechcannonImage::onFire(%this,%obj,%slot)
{
  %obj.toolMag[%obj.currTool] -= 1;
  if(%obj.toolMag[%obj.currTool] < 1)
  {
    %obj.toolMag[%obj.currTool] = 0;
    %obj.setImageAmmo(0,0);
  }
  %spread = 0.0005;
  if(%obj.isCrouched() == 1) %spread -= 0.0002;
  %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %p = new Projectile()
  {
    dataBlock = %this.projectile;
    initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(0),%this.projectile.muzzleVelocity));
    initialPosition = %obj.getMuzzlePoint(0);
    sourceObject = %obj;
    sourceSlot = 0;
    client = %obj.client;
  };
  MissionCleanup.add(%p);
}
