//########## Mech Fist

//### Sounds

datablock AudioProfile(gc_MechSwingSound)
{
  filename = "./swing.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(gc_MechFistHitSound)
{
  filename = "./fistimpact.wav";
  description = AudioClosest3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_MechFistParticle)
{
  dragCoefficient = 1;
  gravityCoefficient = 2;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/chunk";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 1";
  sizes[0] = 0.3;
  sizes[1] = 0;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_MechFistEmitter)
{
  uiName = "";
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 15;
  velocityVariance = 10;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 45;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechFistParticle";
};

datablock ParticleData(gc_MechFistSmokeParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0.5 0.5 0.5 1";
  colors[1] = "0.5 0.5 0.5 0";
  sizes[0] = 1;
  sizes[1] = 2;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_MechFistSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 10;
  periodVarianceMS = 0;
  ejectionVelocity = 15;
  velocityVariance = 15;
  ejectionOffset = 0;
  thetaMin = 45;
  thetaMax = 70;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechFistSmokeParticle";
};

datablock ExplosionData(gc_MechFistExplosion)
{
  lifeTimeMS = 100;
  soundProfile = gc_MechFistHitSound;
  emitter[0] = gc_MechFistEmitter;
  emitter[1] = gc_MechFistSmokeEmitter;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "2 2 2";
  camShakeAmp = "1 1 1";
  camShakeDuration = 1;
  camShakeRadius = 0.5;
};

//### Projectiles

AddDamageType("gc_MechFist",'<bitmap:Add-ons/Vehicle_Mechh/CI_mechfist> %1','%2 <bitmap:Add-ons/Vehicle_Mechh/CI_mechfist> %1',0.2,1);

datablock ProjectileData(gc_MechFistProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 100;
  directDamageType = $DamageType::gc_MechFist;
  radiusDamageType = $DamageType::gc_MechFist;
  brickExplosionRadius = 1;
  brickExplosionImpact = true;
  brickExplosionForce = 20;
  brickExplosionMaxVolume = 24;
  brickExplosionMaxVolumeFloating = 24;
  explosion = gc_MechFistExplosion;
  muzzleVelocity = 100;
  velInheritFactor = 1;
  armingDelay = 0;
  lifetime = 100;
  fadeDelay = 50;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  impactImpulse = 1000;
  verticalImpulse = 1000;
};

//### Item

datablock ItemData(gc_MechFistItem)
{
  uiName = "Mech Fist";
  iconName = "./icon_mechfist";
  image = gc_MechFistImage;
  category = Weapon;
  className = Weapon;
  shapeFile = "./mechfist.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock shapeBaseImageData(gc_MechFistImage)
{
  shapeFile = "./mechfist.dts";
  emap = true;
  correctMuzzleVector = false;
  className = "WeaponImage";
  item = gc_MechFistItem;
  ammo = "";
  projectile = gc_MechFistProjectile;
  projectileType = Projectile;
  melee = true;
  doReaction = false;
  armReady = true;
  armReadyBoth = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.01;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "PreFire1";
  stateAllowImageChange[1] = true;
  stateTimeoutValue[1] = 100;
  stateTransitionOnTimeout[1] = "Ready";
  stateWaitForTimeout[1] = false;

  stateName[2] = "PreFire1";
  stateScript[2] = "onPreFire1";
  stateAllowImageChange[2] = false;
  stateTimeoutValue[2] = 0.1;
  stateTransitionOnTimeout[2] = "Fire1";
  stateSound[2] = gc_MechSwingSound;

  stateName[3] = "Fire1";
  stateTransitionOnTimeout[3] = "CheckFire";
  stateTimeoutValue[3] = 0.2;
  stateFire[3] = true;
  stateAllowImageChange[3] = false;
  stateScript[3] = "onFire";
  stateWaitForTimeout[3] = true;

  stateName[4] = "CheckFire";
  stateTransitionOnTriggerDown[4] = "PreFire2";
  stateAllowImageChange[4] = true;
  stateWaitForTimeout[4] = false;
  stateTransitionOnTimeout[4] = "Ready";
  stateTimeoutValue[4] = 0.2;

  stateName[5] = "PreFire2";
  stateScript[5] = "onPreFire2";
  stateAllowImageChange[5] = false;
  stateTimeoutValue[5] = 0.1;
  stateTransitionOnTimeout[5] = "Fire2";
  stateSound[5] = gc_MechSwingSound;

  stateName[6] = "Fire2";
  stateTransitionOnTimeout[6] = "Ready";
  stateTimeoutValue[6] = 0.2;
  stateFire[6] = true;
  stateAllowImageChange[6] = false;
  stateScript[6] = "onFire";
  stateWaitForTimeout[6] = true;

};

function gc_MechFistImage::onMount(%this,%obj,%slot) { if(!%obj.dataBlock.gc_isMech) { centerPrint(%obj.client,"Only a Mech can use this!",3); %obj.unmountImage(%slot); return; } %obj.playThread(1,armreadyboth); }
function gc_MechFistImage::onPreFire1(%this,%obj,%slot) { %obj.playthread(2,punch1); }
function gc_MechFistImage::onPreFire2(%this,%obj,%slot) { %obj.playthread(2,punch2); }
