//########## Mech Knife

//### Sounds

datablock AudioProfile(gc_MechKnifeHitSound)
{
  filename = "./mechknifehit.wav";
  description = AudioClosest3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_MechKnifeParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = 2;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/star1";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 1 0 1";
  colors[1] = "1 0.5 0 1";
  sizes[0] = 0.3;
  sizes[1] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_MechKnifeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 15;
  velocityVariance = 10;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 45;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechKnifeParticle";
};

datablock ExplosionData(gc_MechKnifeExplosion)
{
  lifeTimeMS = 100;
  soundProfile = gc_MechKnifeHitSound;
  emitter[0] = gc_MechKnifeEmitter;
  emitter[1] = gc_MechFistSmokeEmitter;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "2 2 2";
  camShakeAmp = "1 1 1";
  camShakeDuration = 1;
  camShakeRadius = 0.5;
};

//### Projectiles

AddDamageType("gc_MechKnife",'<bitmap:Add-ons/Vehicle_Mechh/CI_mechknife> %1','%2 <bitmap:Add-ons/Vehicle_Mechh/CI_mechknife> %1',0.2,1);

datablock ProjectileData(gc_MechKnifeProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 200;
  directDamageType = $DamageType::gc_MechKnife;
  radiusDamageType = $DamageType::gc_MechKnife;
  brickExplosionRadius = 1;
  brickExplosionImpact = true;
  brickExplosionForce = 20;
  brickExplosionMaxVolume = 24;
  brickExplosionMaxVolumeFloating = 24;
  explosion = gc_MechKnifeExplosion;
  muzzleVelocity = 100;
  velInheritFactor = 1;
  armingDelay = 0;
  lifetime = 100;
  fadeDelay = 50;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  impactImpulse = 1000;
  verticalImpulse = 1000;
};

//### Item

datablock ItemData(gc_MechKnifeItem)
{
  uiName = "Mech Knife";
  iconName = "./icon_mechknife";
  image = gc_MechKnifeImage;
  category = Weapon;
  className = Weapon;
  shapeFile = "./mechknife.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock shapeBaseImageData(gc_MechKnifeImage)
{
  shapeFile = "./mechknife.dts";
  emap = true;
  correctMuzzleVector = false;
  className = "WeaponImage";
  item = gc_MechKnifeItem;
  ammo = "";
  projectile = gc_MechKnifeProjectile;
  projectileType = Projectile;
  melee = true;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.01;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "PreFire";
  stateAllowImageChange[1] = true;

  stateName[2] = "PreFire";
  stateScript[2] = "onPreFire";
  stateAllowImageChange[2] = false;
  stateTimeoutValue[2] = 0.1;
  stateTransitionOnTimeout[2] = "Fire";

  stateName[3] = "Fire";
  stateTransitionOnTimeout[3] = "CheckFire";
  stateTimeoutValue[3] = 0.3;
  stateFire[3] = true;
  stateAllowImageChange[3] = false;
  stateSequence[3] = "Fire";
  stateScript[3] = "onFire";
  stateWaitForTimeout[3] = true;
  stateSound[3] = gc_MechSwingSound;

  stateName[4] = "CheckFire";
  stateTransitionOnTriggerUp[4] = "Ready";
  stateTransitionOnTriggerDown[4] = "PreFire";
};

function gc_MechKnifeImage::onMount(%this,%obj,%slot) { if(!%obj.dataBlock.gc_isMech) { centerPrint(%obj.client,"Only a Mech can use this!",3); %obj.unmountImage(%slot); return; } }

function gc_MechKnifeImage::onPreFire(%this,%obj,%slot) { %obj.playthread(2,wrench); }
function gc_MechKnifeImage::onFire(%this,%obj,%slot) { %obj.playthread(2,activate); parent::onFire(%this,%obj,%slot); }
