//########## Mech Rocketlauncher

//### Sounds

datablock AudioProfile(gc_MechlauncherFireSound)
{
  filename = "./launcher.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_MechlauncherExplosionSound)
{
  filename = "./launcherhit.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_MechlauncherPumpSound)
{
  filename = "./launcherpump.wav";
  description = AudioClose3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_RocketTrailParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 2000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.8 0.8 0.8 1";
  colors[1] = "0.8 0.8 0.8 0.5";
  colors[2] = "0.8 0.8 0.8 0";
  sizes[0] = 0.4;
  sizes[1] = 0.8;
  sizes[2] = 2;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_RocketTrailEmitter)
{
  uiName = "";
  ejectionPeriodMS = 6;
  periodVarianceMS = 0;
  ejectionVelocity = 10;
  velocityVariance = 5;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 45;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_RocketTrailParticle";
};

datablock ParticleData(gc_MechlauncherExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 100;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/star1";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 12;
  sizes[1] = 6;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_MechlauncherExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 2;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechlauncherExplosionParticle";
};

datablock ParticleData(gc_MechlauncherSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1500;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "1 1 1 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 8;
  sizes[1] = 16;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_MechlauncherSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 15;
  periodVarianceMS = 0;
  ejectionVelocity = 10;
  velocityVariance = 5;
  ejectionOffset = 2;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_MechlauncherSmokeParticle";
};

datablock ExplosionData(gc_MechlauncherExplosion)
{
  lifeTimeMS = 500;
  soundProfile = gc_MechlauncherHitSound;
  emitter[0] = gc_MechlauncherExplosionEmitter;
  emitter[1] = gc_MechlauncherSmokeEmitter;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "5 5 5";
  camShakeDuration = 1;
  camShakeRadius = 10;
  radiusDamage = 50;
  damageRadius = 5;
  impulseForce = 500;
  impulseRadius = 10;
};

datablock DebrisData(gc_MechlauncherShellDebris)
{
  shapeFile = "./mechlaunchershell.dts";
  lifetime = 2;
  minSpinSpeed = -400;
  maxSpinSpeed = 200;
  elasticity = 0.5;
  friction = 0.2;
  numBounces = 3;
  staticOnMaxBounce = true;
  snapOnMaxBounce = false;
  fade = true;
  gravModifier = 2;
};

//### Projectile

AddDamageType("gc_Mechlauncher",'<bitmap:Add-ons/Vehicle_Mechh/CI_mechlauncher> %1','%2 <bitmap:Add-ons/Vehicle_Mechh/CI_mechlauncher> %1',0.2,1);

datablock ProjectileData(gc_MechlauncherProjectile)
{
  uiName = "";
  projectileShapeName = "./rocket.dts";
  directDamage = 100;
  directDamageType = $DamageType::gc_Mechlauncher;
  radiusDamageType = $DamageType::gc_Mechlauncher;
  brickExplosionRadius = 5;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 24;
  brickExplosionMaxVolumeFloating = 24;
  impactImpulse = 1000;
  verticalImpulse = 300;
  explosion = gc_MechlauncherExplosion;
  particleEmitter = gc_RocketTrailEmitter;
  muzzleVelocity = 100;
  verInheritFactor = 0;
  lifetime = 5000;
  fadeDelay = 5000;
  armingDelay = 0;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0;
};

//### Item

datablock ItemData(gc_MechlauncherItem)
{
  uiName = "Mech Rocketlauncher";
  iconName = "./icon_mechlauncher";
  image = gc_MechlauncherImage;
  category = Weapon;
  className = Weapon;
  shapeFile = "./mechlauncher.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock shapeBaseImageData(gc_MechlauncherImage)
{
  shapeFile = "./mechlauncher.dts";
  emap = true;
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = gc_MechlauncherItem;
  ammo = "";
  projectile = gc_MechlauncherProjectile;
  projectileType = Projectile;
  projectilemagcount = 3;
  casing = gc_MechlauncherShellDebris;
  shellExitDir = "1 0.5 0.2";
  shellExitVariance = 10;
  shellVelocity = 6;
  melee = false;
  doReaction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "AmmoCheck";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;
  stateTransitionOnNoAmmo[1] = "Reload";

  stateName[2] = "Fire";
  stateTransitionOnTimeout[2] = "AmmoCheck";
  stateTimeoutValue[2] = "0.65";
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateWaitForTimeout[2] = true;
  stateSound[2] = gc_MechlauncherFireSound;
  stateScript[2] = "onFire";
  stateSequence[2] = "Fire";

  stateName[3] = "AmmoCheck";
  stateTimeoutValue[3] = "0.35";
  stateTransitionOnTimeout[3] = "Ready";
  stateSequence[3] = "Pump";
  stateSound[3] = gc_MechlauncherPumpSound;
  stateEjectShell[3] = true;
  stateEmitter[3] = gc_RocketTrailEmitter;
  stateEmitterTime[3] = 0.2;
  stateEmitterNode[3] = "tailPoint";
  stateScript[3] = "onAmmoCheck";

  stateName[4] = "Reload";
  stateTimeoutValue[4] = 4;
  stateTransitionOnTimeout[4] = "Done";
  stateWaitForTimeout[4] = true;
  stateAllowImageChange[4] = true;
  stateScript[4] = "onReloadStart";
  stateSequence[4] = "Empty";
  stateSound[4] = gc_MagOutSound;

  stateName[5] = "Done";
  stateTransitionOnTimeout[5] = "Ready";
  stateTimeoutValue[5] = 0.1;
  stateAllowImageChange[5] = true;
  stateScript[5] = "onReload";
  stateSound[5] = gc_MagInSound;
  stateSequence[5] = "Ready";
};

function gc_MechlauncherImage::onMount(%this,%obj,%slot) { parent::onMount(%this,%obj,%slot); if(!%obj.dataBlock.gc_isMech) { centerPrint(%obj.client,"Only a Mech can use this!",3); %obj.unmountImage(%slot); return; } }
function gc_MechlauncherImage::onAmmoCheck(%this,%obj,%slot) { if(%obj.toolMag[%obj.currTool] > %this.projectilemagcount) { %obj.toolMag[%obj.currTool] = %this.projectilemagcount; } if(%obj.toolMag[%obj.currTool] < 1) { %obj.toolMag[%obj.currTool] = 0; %obj.setImageAmmo(0,0); } }
function gc_MechlauncherImage::onReloadStart(%this,%obj,%slot) { %obj.playThread(2,shiftRight); serverPlay3D(gc_FLReloadStartSound,%obj.getPosition()); }
function gc_MechlauncherImage::onReload(%this,%obj,%slot) { %obj.playThread(2,plant); serverPlay3D(gc_FLReloadEndSound,%obj.getPosition()); %obj.toolMag[%obj.currTool] = %this.projectilemagcount; %obj.setImageAmmo(0,1); }

function gc_MechlauncherImage::onFire(%this,%obj,%slot)
{
  %obj.toolMag[%obj.currTool] -= 1;
  if(%obj.toolMag[%obj.currTool] < 1)
  {
    %obj.toolMag[%obj.currTool] = 0;
    %obj.setImageAmmo(0,0);
  }
  %spread = 0.0005;
  if(%obj.isCrouched() == 1) %spread -= 0.0002;
  %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
  %p = new Projectile()
  {
    dataBlock = %this.projectile;
    initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(0),%this.projectile.muzzleVelocity));
    initialPosition = %obj.getMuzzlePoint(0);
    sourceObject = %obj;
    sourceSlot = 0;
    client = %obj.client;
  };
  MissionCleanup.add(%p);
}

function gc_MechLauncherProjectile::onExplode(%this,%obj,%pos,%a)
{
  InitContainerRadiusSearch(%obj.getPosition(),5,$TypeMasks::PlayerObjectType);
  while((%target = containerSearchNext()) != 0)
    if(miniGameCanDamage(%obj,%target) && getMiniGameFromObject(%target) != -1)
      if(isObject(%target.getObjectMount()) && %target.getObjectMount().dataBlock.protectPassengersBurn == 0) gc_burning(%target,10,%obj);
  parent::onExplode(%this,%obj,%pos,%a);
}
