//########## Mech

exec("./burnstatus.cs");
exec("./mech.cs");
exec("./mechfist.cs");
exec("./mechknife.cs");
exec("./mechcannon.cs");
exec("./mechlauncher.cs");

AddDamageType("gc_MechStomp",'%1 stomped himself into the ground!','%2 stomped %1 into the ground!',1,1);

package gc_Mech
{
  function GameConnection::spawnPlayer(%this)
  {
    parent::SpawnPlayer(%this);
    if(%this.dataBlock.gc_isMech)
    {
      %this.player.gc_MechFootsteps();
      gc_MechStatus(%this.player);
    }
  }
  function Player::setDataBlock(%this,%db)
  {
    parent::setDataBlock(%this,%db);
    if(%db.gc_isMech) { %this.gc_MechFootsteps(); }
  }
  function GameConnection::applyBodyColors(%client)
  {
    parent::applyBodyColors(%client);
    if(!%client.isBot && !isObject(%client.player)) return;
    if(%client.isBot) { %this = %c = %client; }
    else {
      %this = %client.player; %c = %client; }
    if(%this.dataBlock.getName() $= "gc_MechPlayer")
    {
      %this.setNodeColor("chest",%c.chestColor);
      %this.setNodeColor("headskin","0 0 0 1");
      %this.setNodeColor("pack",%c.packColor);
      %this.setNodeColor("pants",%c.hipColor);
      %this.setNodeColor("larm",%c.larmColor);
      %this.setNodeColor("rarm",%c.rarmColor);
      %this.setNodeColor("lhand",%c.larmColor);
      %this.setNodeColor("rhand",%c.rarmColor);
      %this.setNodeColor("lshoe",%c.llegColor);
      %this.setNodeColor("rshoe",%c.rlegColor);
    }
  }
  function Armor::Damage(%this,%obj,%sourceObject,%pos,%damage,%damageType)
  {
    if(%damageType == $DamageType::vehicle) %damage = 0;
    if(%obj.dataBlock.gc_shield)
    {
      if(%damage > %obj.shield)
      {
        %damage -= %obj.shield;
        %obj.shield = 0;
        %obj.shielddelay = 7;
      }
      else
      {
        %obj.shield -= %damage;
        %damage = 0;
        %obj.shielddelay = 7;
      }
    }
    parent::Damage(%this,%obj,%sourceObject,%pos,%damage,%damageType);
  }
  function Armor::onTrigger(%this,%obj,%num,%trig)
  {
    if(%this.getName() $= "gc_MechPlayer" && %num == 4)
    {
      if(%trig == 1 && %obj.getEnergyLevel() > 1) %obj.playAudio(0,gc_MechJetSound);
      else
        %obj.playAudio(0,gc_MechJetOffSound);
    }
    parent::onTrigger(%this,%obj,%num,%trig);
  }
  function Armor::onImpact(%this,%obj,%col,%vec,%vel)
  {
    if(%this.getName() $= "gc_MechPlayer" && %vel >= 20)
    {
      %p = new Projectile()
      {
        dataBlock = gc_MechImpact;
        initialPosition = VectorAdd(%obj.getPosition(),"0 0 -1");
        initialVelocity = "0 0 1";
        sourceObject = %obj;
        client = %obj.client;
        sourceSlot = 0;
        originPoint = %obj.getPosition();
      };
      MissionCleanup.add(%p);
      if(getMinigameFromObject(%obj) != -1) {
      if(%col.getClassName() $= "Player" || %col.getClassName() $= "AIPlayer")
      {
        if(miniGameCanDamage(%obj,%col)) %col.damage(%obj,%obj.getPosition(),200,$DamageType::gc_MechStomp);
      }
      InitContainerRadiusSearch(%obj.getPosition(),10,$TypeMasks::PlayerObjectType || $TypeMasks::VehicleObjectType);
      while((%target = containerSearchNext()) != 0)
      {
        if(!isObject(%target)) continue;
        if(%target == %obj) continue;
        %vec1 = VectorSub(%target.getPosition(),%obj.getPosition());
        %vec2 = VectorNormalize(getWord(%vec1,0) SPC getWord(%vec1,1) SPC "0");
        %impulse = getWord(%vec2,0) SPC getWord(%vec2,1) SPC "1";
        %target.applyImpulse(%obj.getPosition(),VectorScale(%impulse,1000));
        if(miniGameCanDamage(%obj,%target)) %target.damage(%obj,%obj.getPosition(),50,$DamageType::gc_MechStomp);
      } }
    }
    %vel = 1;
    %vec = VectorNormalize(%vec);
    parent::onImpact(%this,%obj,%col,%vec,%vel);
  }
  function Player::gc_MechFootsteps(%this)
  {
    if(!isObject(%this)) return;
    if(%this.dataBlock.getName() !$= "gc_MechPlayer") return;
    %pos = getWords(%this.getPosition(),0,1);
    if(%this.f_lastPos !$= getWords(%this.getPosition(),0,1) && %this.isOnGround() && !%this.isMounted())
    {
      if(getRandom() < 0.5) %sound = gc_MechStep1Sound;
      else
        %sound = gc_MechStep2Sound;
      serverplay3d(%sound,VectorAdd(%this.getPosition(),"0 0 -2"));
      %this.f_lastPos = getWords(%this.getPosition(),0,1);
    }
    %this.schedule(%this.dataBlock.footstepdelay,gc_MechFootsteps);
  }
  //From AGILE Player
  function Player::IsOnGround(%player)
  {
    %pos = %player.getPosition();
    %scale = %player.getScale();
    %xs = getWord(%scale,0);
    %ys = getWord(%scale,1);
    %nw = vectorAdd(%pos,0 - (0.75 * %xs) SPC 0 - (0.75 * %ys) SPC 0);
    %dnw = vectorAdd(%nw,"0 0 -0.5");
    %ne = vectorAdd(%pos,(0.75 * %xs) SPC 0 - (0.75 * %ys) SPC 0);
    %dne = vectorAdd(%ne,"0 0 -0.5");
    %se = vectorAdd(%pos,(0.75 * %xs) SPC (0.75 * %ys) SPC 0);
    %dse = vectorAdd(%se,"0 0 -0.5");
    %sw = vectorAdd(%pos,0 - (0.75 * %xs) SPC (0.75 * %ys) SPC 0);
    %dsw = vectorAdd(%sw,"0 0 -0.5");
    %dpos = vectorAdd(%pos,"0 0 -0.5");
    %raynw = ag_bicheck(getWord(containerRaycast(%nw,%dnw,$TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ShapeBaseObjectType),0));
    %rayne = ag_bicheck(getWord(containerRaycast(%ne,%dne,$TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ShapeBaseObjectType),0));
    %rayse = ag_bicheck(getWord(containerRaycast(%se,%dse,$TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ShapeBaseObjectType),0));
    %raysw = ag_bicheck(getWord(containerRaycast(%sw,%dsw,$TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ShapeBaseObjectType),0));
    %rayce = ag_bicheck(getWord(containerRaycast(%pos,%dpos,$TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::ShapeBaseObjectType),0));
    if(%raynw || %rayne || %rayse || %raysw || %rayce) return 1;
    else
      return 0;
  }
  function ag_bicheck(%obj)
  {
    if(!isObject(%obj)) return 0;
    if(%obj.getClassName() $= "fxDTSbrick")
    {
      if(%obj.isColliding() && %obj.isRendering()) return 1;
      return 0;
    }
    return 1;
  }
};
activatePackage(gc_Mech);

package gc_SimpleReloadPackage
{
  function serverCmdLight(%client)
  {
    if(isObject(%client.player)) {
    %player = %client.player;
    %image = %player.getMountedImage(0);
    if(%image.projectilemagcount > 1)
    {
      if(%player.getImageState(0) $= "Ready" || %player.getImageState(0) $= "Empty")
      {
        if(%player.toolMag[%player.currTool] < %image.projectilemagcount) { %player.setImageAmmo(0,0); return; }
        else
          parent::serverCmdLight(%client);
      }
    } }
    parent::serverCmdLight(%client);
  }
};
activatePackage(gc_SimpleReloadPackage);
